/*============================================================================
                          FIBONACCI NUMBERS
Reference: Pettorossi, A. and Burstall, R.M.:" Deriving very efficient
algorithms for evaluating linear recurrence relations using the program
transformation technique", Acta Informatica, Vol.18, (1982), 181-206.
=========================================================================== */
#include  <iostream.h>
int A[2]={0,0};                        // A is a global array
int square(int n) {return n*n;}
//----------------- Recursive Fibonacci --------------------------------------
int rec_fib(int n)
{if (n==0) {return 0;} else {if (n==1) {return 1;} else
{return rec_fib(n-1) + rec_fib(n-2);};};}
//----------------- Linear Fibonacci ----------------------------------------
void g(int n)
{if (n==1) {A[0]=1; A[1]=0;}
else {g(n-1); int u=A[0]; int v=A[1]; A[0]=u+v; A[1]=u;};}

int lin_fib(int n) {if (n==0) {return 0;} else {g(n); return A[0];};}
//----------------- Logarithmic Fibonacci -----------------------------------
bool odd(int n) {return (n/2)*2!=n;}

void r(int n)
{if (n==0) {A[0]=0; A[1]=1;}  else
if (odd(n))  {r((n-1)/2); int u=square(A[0]+A[1]) + square(A[0]);
              int v=square(A[0]) + 2*A[0]*A[1]; A[0]=u; A[1]=v;}
else {r(n/2); int u=square(A[0]) + 2*A[0]*A[1];
      int v=square(A[0]) + square(A[1]); A[0]=u; A[1]=v;};}

int log_fib(int n)
{if (n==0) {return 0;} else {if (n==1) {return 1;} else
{if (odd(n)) {r((n-1)/2); return (square(A[0]) + square(A[0]+A[1]));}
else {r(n/2); return (square(A[0]) + 2*A[0]*A[1]);};};};}
//----------------------------------------------------------------------------
void main()
{cout << "Input for Recursive Fibonacci: ";
cout << "(type a non-negative integer and CR)\n";
int n; cin >> n;
cout << "Recursive Fibonacci("<<n<<") = "<<rec_fib(n)<<"\n";
cout << "\nInput for Linear Fibonacci: ";
cout << "(type a non-negative integer and CR)\n";
cin >> n;
cout << "Linear Fibonacci("<<n<<") = "<< lin_fib(n) <<"\n";
cout << "\nInput for Logarithmic Fibonacci: ";
cout << "(type a non-negative integer and CR)\n";
cin >> n;
cout << "Logarithmic Fibonacci("<<n<<") = "<< log_fib(n) <<"\n";
}
/*input: output:
------------------------------------------------------------------------------
         Input for Recursive Fibonacci: (type a non-negative integer and CR)
   2 CR
         Recursive Fibonacci(2) = 1

         Input for Linear Fibonacci: (type a non-negative integer and CR)
   8 CR
         Linear Fibonacci(8) = 21

         Input for Logarithmic Fibonacci: (type a non-negative integer and CR)
  22 CR
         Logarithmic Fibonacci(22) = 17711
--------------------------------------------------------------------------- */
